from flask import flash

from database import app

from covid19.blueprints.application.application_service_config import ApplicationServiceConfig
from covid19.blueprints.application.application_service_download import ApplicationServiceDownload
from covid19.blueprints.owid.owid_service_import import OwidServiceImport
from covid19.blueprints.owid.owid_service_update import OwidServiceUpdate
from covid19.blueprints.owid.owid_model import OwidDateReported, OwidContinent, OwidCountry, OwidData


class OwidTestService:
    def __init__(self, database):
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" OwidTestService [init]")
        app.logger.debug("------------------------------------------------------------")
        self.__database = database
        self.cfg = ApplicationServiceConfig.create_config_for_owid()
        app.logger.debug("------------------------------------------------------------")
        app.logger.info(" OwidTestService [ready]")

    def delete_last_day(self):
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" OwidTestService.delete_last_day() [START]")
        app.logger.debug("------------------------------------------------------------")
        joungest_datum_str = OwidData.get_joungest_datum()
        joungest_datum = OwidDateReported.find_by_date_reported(joungest_datum_str)
        app.logger.info("joungest_datum:")
        app.logger.info(joungest_datum)
        app.logger.info("WhoData.get_data_for_one_day(joungest_datum):")
        i = 0
        for data in OwidData.get_data_for_one_day(joungest_datum):
            i += 1
            line = " | " + str(i) + " | " + str(data.date_reported) + " | " + data.country.location + " | to be deleted"
            app.logger.info(line)
        app.logger.info("WhoData.delete_data_for_one_day(joungest_datum)")
        OwidData.delete_data_for_one_day(joungest_datum)
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" OwidTestService.delete_last_day() [DONE]")
        app.logger.debug("------------------------------------------------------------")

    def run_update_star_schema_incremental(self):
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" OwidTestService.run_update_star_schema_incremental() [START]")
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" TODO....")
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" OwidTestService.run_update_star_schema_incremental() [DONE]")
        app.logger.debug("------------------------------------------------------------")
